;Project Modalys-Visualisation
;===============================
;
;Programmed by Jialin Liu in August 2020, the idea is to construct the mesh file directly from OM. (still not accomplished)
;Done: the simplified transform / duplicate / node indexing methode (13. August. 2020)
;(in-package :fem)
(in-package :om)

;Modalys Geometrical Construction in OM


;Project Modalys-Visualisation
;===============================
;Modalys Geometrical Construction in OM

(defun om-dot (p1 p2)
  (reduce #'+ (om* p1 p2)))
;(om-dot '(1 1 1) '(0 0 1))

(defun determinant (a b c d)
  (- (* a d) (* b c)))

(defun om-cross (p1 p2)
  (list (determinant (cadr p1) (cadr p2) (caddr p1) (caddr p2)) (determinant (caddr p1) (caddr p2) (car p1) (car p2) ) (determinant (car p1) (car p2) (cadr p1) (cadr p2))))
;(om-cross '(6 0 0) '(5 2 -2))
;(om-cross '(8 2 1) '(4 3 9))


(defun point-translation (p m)
  "p=input point, m=vector for translation"
  (om+ p m))

(defun point-homothety (p c r)
  "p=input point, c=center point, r=homothety rate"
  (om+ (om* (om- p c) r) c))
;(point-homothety  '(0.5 2.0 0) '(0 0 0) -2)

(defun point-reflection (p n o)
  "p=input point, n=normal vector, o=invariant point"
  (let* ((n1 (om-scale/sum n 1.0))
         (v-real (om- p o)))
    (om+ o (om- v-real 
                (om* n1 
                     (om* 2 
                          (om-dot v-real n1)))
    ))))
;(point-reflection '(0 0 3) '(0 0 1) '(0 0 0))
;(point-reflection '(0 3) '(0 1) '(0 0))

(defun point-rotation (p a o d)
  "p=input point, a=axis (preferable just use 1 and 0), o=origin point, d=angle of rotation in degrees"
  (let* ((p (if (= 3 (length p)) p (append p (list 0))))
         (a (if (= 3 (length a)) a '(0 0 1)))
         (o (if (= 3 (length o)) o (append o (list 0))))
         (v-real (om- p o)))
    (om-round 
     (om+ (om+ o 
               (om* (om* (om-dot a v-real)
                         (- 1 
                            (cos (* pi 
                                    (/ d 180)))))
                    a))
          (om+ (om* (cos (* pi 
                            (/ d 180)))
                    v-real)
               (om* (sin (* pi 
                            (/ d 180))) 
                    (om-cross a v-real))))
     8)))


;(point-rotation '(5 0 0) '(0 0 1) '(0 0 0) 90)
;(point-rotation '(5 0) '(0 0) '(0 0) 180)
;(cos 0.5)



;transform-translation
;transform-reflection
;transform-homothety
;transform-rotation
;===========


(defmethod* transform-translation ((p list) (m list))
            :doc "the om equivalant of the modalisp 
(transform 'translation sth-tobe-transform translation-vector), 
the first argument could be:
1. point of (list x y z)
2. list of points of (list x y z)
3. bpc (or in some case bpf)
4. bpc-lib (or in some case bpc-lib)
5. 3dc
6. 3dc-lib"
            (if (atom (car p)) 
                (point-translation p m)
              (mapcar #'(lambda (x) (point-translation x m)) p)))
;(transform-translation '(0 0 0) '(0 0 5))
;(transform-translation '((0 0 0) (5 0 0)) '(0 0 5))

(defmethod* transform-translation ((bpc bpc) (m list))
            (let* ((xy-list (mat-trans (transform-translation (point-pairs bpc) m))))
              (simple-bpf-from-list (car xy-list) (cadr xy-list) 'bpc 5)))

(defmethod* transform-translation ((3dc 3dc) (m list))
            (let* ((xyz-list (mat-trans (transform-translation (point-pairs 3dc) m))))
              (3dc-from-list (car xyz-list) (cadr xyz-list) (caddr xyz-list) '3dc 5)))

(defmethod* transform-translation ((bpcl bpc-lib) (m list))
            (make-instance 'bpc-lib :bpf-list 
                           (loop for bpc in (bpf-list bpcl)
                                 collect (transform-translation bpc m))))

(defmethod* transform-translation ((3dcl 3dc-lib) (m list))
            (make-instance '3dc-lib :bpf-list 
                           (loop for 3dc in (bpf-list 3dcl)
                                 collect (transform-translation 3dc m))))



;----------------------start-up-duplication

(defun distance-points (p1 p2)
  "distance of 2 points in 3D space"
  (sqrt (abs (+ (expt (- (car p1) (car p2)) 2) (expt (- (cadr p1) (cadr p2)) 2) (expt (- (caddr p1) (caddr p2)) 2)))))


(defmethod* merge-graphics ((lolop list) (method number))
            :menuins '((1 (("closest" 0) ("flat" 1))))
            :doc "merge the 3dc-lib as a 3dcs, by connecting the closest end of the graphic together.
if the method is 1, the point with be put into a flat list... so 0 = closest, 1 = flat directly, 
the input could be either a list of list of points, or a 3dc-lib, the result is a list of points, which could be mat-transed for the 3dc"  
            (cond ((= method 1) (flat lolop 1))
                  (t (let* ((res (car lolop)))
                       (loop for i from 1 to (- (length lolop) 1)
                             for lop = (nth i lolop)
                             do
                             (setf res (append res 
                                               (let* ((dis-beg (distance-points (car (last res)) (car lop)))
                                                      (dis-end (distance-points (car (last res)) (car (last lop))))
                                                      )
                                                 (cond ((<= dis-beg dis-end) lop)
                                                       (t (reverse lop))))))) 
                       res))))

(defun depth (list)
  (if (listp list)
      (+ 1 (reduce #'max (mapcar #'depth list)
                   :initial-value 0))
    0))

(setf *graphic-merge-method* 0)

(defmethod* set-merge-method (method)
            :menuins '((0 (("closest-visual" 0) ("flat-formal" 1))))
            :doc"set graphic-merge-method, 0 = connect the closest end (closest, better visualized) , 1 = direct in order (flat, better formalized)"
            (setf *graphic-merge-method* method))

(defmethod* graphic-out-format ((list-in list) (out-mode number))
            :menuins '((1 (("list" 0) ("3dc" 1) ("3dc-lib" 2))))
            :doc "process list of points (like 3DC) , or list of list of points (like 3DC-LIB) into a determined format,
the method of merging graphics see function merge-graphics...
out-mode meaning:
0 = list
1 = 3dc
2 = 3dc-lib"
            (cond ((= out-mode 0) list-in)
                  ((= out-mode 1) (if (atom (caar list-in)) 
                                      (let ((transed (mat-trans list-in)))
                                        (3dc-from-list (car transed) (cadr transed) (caddr transed) '3dc 5))
                                    (let ((transed (mat-trans (merge-graphics list-in *graphic-merge-method*)))) ;====>> here to change the merge methode!
                                      (3dc-from-list (car transed) (cadr transed) (caddr transed) '3dc 5))))
                  (t (if (atom (caar list-in)) 
                         (let ((transed (mat-trans list-in)))
                           (progn 
                             (3dc-from-list (car transed) (cadr transed) (caddr transed) '3dc 5)
                             (print "sorry, could not build 3dc-lib with 2-layer point list!! the result is forced to be a 3dc")))
                       (make-instance '3dc-lib :bpf-list
                                      (loop for lop in list-in
                                            collect (let ((transed (mat-trans lop)))
                                                      (3dc-from-list (car transed) (cadr transed) (caddr transed) '3dc 5))))))))
             

;-------------------duplicate-translation

(defmethod* duplicate-translation ((p list) (step number) (m list) (out-mode number))
            :menuins '((3 (("list" 0) ("3dc" 1) ("3dc-lib" 2))))
            :doc "the om equivalant of the modalisp 
(duplicate 'translation sth-tobe-transform repitition translation-vector), 
the first argument could be:
1. point of (list x y z)
2. list of points of (list x y z)
3. list of list of points of (list x y z)
4. bpc (or in some case bpf)
5. bpf
6. 3dc
7. 3dc-lib"
            (graphic-out-format
             (cond 
              ((atom (car p)) (loop for i from 0 to step
                                    collect (om+ p (om* m i))))
              ((atom (caar p)) (mat-trans (mapcar #'(lambda (x) (duplicate-translation x step m 0)) p)))
              ((atom (caaar p)) (mat-trans (mapcar #'(lambda (x) (duplicate-translation x step m 0)) (merge-graphics p *graphic-merge-method*))))
              )
             out-mode))

(defmethod* duplicate-translation ((3dc 3dc) (step number) (m list) (out-mode number))
            (duplicate-translation (point-pairs 3dc) step m out-mode))

(defmethod* duplicate-translation ((3dcl 3dc-lib) (step number) (m list) (out-mode number))
            (duplicate-translation 
             (merge-graphics (loop for 3dc in (bpf-list 3dcl)
                                   collect (point-pairs 3dc)) *graphic-merge-method*)
                   step m out-mode))

(defmethod* duplicate-translation ((bpc bpc) (step number) (m list) (out-mode number))
            (duplicate-translation (loop for p in (point-pairs bpc)
                                         collect (append p (list 0))) step m out-mode))

(defmethod* duplicate-translation ((bpf bpf) (step number) (m list) (out-mode number))
            (duplicate-translation (loop for p in (point-pairs bpf)
                                         collect (append p (list 0))) step m out-mode))

;=============Homothety

(defmethod* transform-homothety ((p list) (c list) (r number))
            :doc "the om equivalant of the modalisp 
(transform 'homothethy sth-to-be-homothety central-point homothety-rate), 
the homothety is equal to the similarity in geometry,
the first argument could be:
1. point of (list x y z)
2. list of points of (list x y z)
3. bpc (or in some case bpf)
4. bpc-lib (or in some case bpc-lib)
5. 3dc
6. 3dc-lib"
            (if (atom (car p)) 
                (point-homothety p c r)
              (mapcar #'(lambda (x) (point-homothety x c r)) p)))
;(transform-homothety '(0 0 0) '(0 0 5) 0.5)
;(transform-homothety '((0 0 0) (5 0 0)) '(0 0 5) 0.5)

(defmethod* transform-homothety ((bpc bpc) (c list) (r number))
            (let* ((xy-list (mat-trans (transform-homothety (point-pairs bpc) c r))))
              (simple-bpf-from-list (car xy-list) (cadr xy-list) 'bpc 5)))

(defmethod* transform-homothety ((3dc 3dc) (c list) (r number))
            (let* ((xyz-list (mat-trans (transform-homothety (point-pairs 3dc) c r))))
              (3dc-from-list (car xyz-list) (cadr xyz-list) (caddr xyz-list) '3dc 5)))

(defmethod* transform-homothety ((bpcl bpc-lib) (c list) (r number))
            (make-instance 'bpc-lib :bpf-list 
                           (loop for bpc in (bpf-list bpcl)
                                 collect (transform-homothety bpc c r))))

(defmethod* transform-homothety ((3dcl 3dc-lib) (c list) (r number))
            (make-instance '3dc-lib :bpf-list 
                           (loop for 3dc in (bpf-list 3dcl)
                                 collect (transform-homothety 3dc c r))))


;------------duplicate-homothety

(defmethod* duplicate-homothety ((p list) (step number) (c list) (r number) (out-mode number))
            :menuins '((4 (("list" 0) ("3dc" 1) ("3dc-lib" 2))))
            :doc "the om equivalant of the modalisp 
(duplicate 'homothety sth-tobe-extruded repitition homothety-central-point homothety-rate), 
the first argument could be:
1. point of (list x y z)
2. list of points of (list x y z)
3. list of list of points of (list x y z)
4. bpc (or in some case bpf)
5. bpf
6. 3dc
7. 3dc-lib"
            (graphic-out-format
             (cond 
              ((atom (car p)) (loop for i from 0 to step
                                    collect (point-homothety p c (expt r i)
                                    )))
              ((atom (caar p)) (mat-trans (mapcar #'(lambda (x) (duplicate-homothety x step c r 0)) p)))
              ((atom (caaar p)) (mat-trans (mapcar #'(lambda (x) (duplicate-homothety x step c r 0)) (merge-graphics p *graphic-merge-method*))))
              )
             out-mode))

(defmethod* duplicate-homothety ((3dc 3dc) (step number) (c list) (r number) (out-mode number))
            (duplicate-homothety (point-pairs 3dc) step c r out-mode))

(defmethod* duplicate-homothety ((3dcl 3dc-lib) (step number) (c list) (r number) (out-mode number))
            (duplicate-homothety 
             (merge-graphics (loop for 3dc in (bpf-list 3dcl)
                                   collect (point-pairs 3dc)) *graphic-merge-method*)
                   step c r out-mode))

(defmethod* duplicate-homothety ((bpc bpc) (step number) (c list) (r number) (out-mode number))
            (duplicate-homothety (loop for p in (point-pairs bpc)
                                         collect (append p (list 0))) step c r out-mode))

(defmethod* duplicate-homothety ((bpf bpf) (step number) (c list) (r number) (out-mode number))
            (duplicate-homothety (loop for p in (point-pairs bpf)
                                         collect (append p (list 0))) step c r out-mode))




;=============Reflection
(defmethod* transform-reflection ((p list) (n list) (o list))
            :doc "the om equivalant of the modalisp 
(transform 'reflection sth-to-be-reflected normal-vector invariant-point), 
!!!! the function is still a bit problematic, when the normal vector is not 1.. but sth strange like (6 2 1), it will scale the object not proportionally in each directions.. so please help to correct the formula in the function (point-reflection) if you know better about the modalys algorithm.!!!!
!!! 2D reflection works not normally.. Some point jumps quite strange.. should have an individual formula which is quite simple !!!
the first argument could be:
1. point of (list x y z)
2. list of points of (list x y z)
3. bpc (or in some case bpf)
4. bpc-lib (or in some case bpc-lib)
5. 3dc
6. 3dc-lib"
            (if (atom (car p)) 
                (point-reflection p n o)
              (mapcar #'(lambda (x) (point-reflection x n o)) p)))
;(transform-reflection '(0 0 3) '(0 0 1) '(0 0 0))
;(transform-reflection '((0 0 0) (5 0 0)) '(1 0 0) '(0 0 0))

(defmethod* transform-reflection ((bpc bpc) (n list) (o list))
            (let* ((xy-list (mat-trans (transform-reflection (point-pairs bpc) n o))))
              (simple-bpf-from-list (car xy-list) (cadr xy-list) 'bpc 5)))

(defmethod* transform-reflection ((3dc 3dc) (n list) (o list))
            (let* ((xyz-list (mat-trans (transform-reflection (point-pairs 3dc) n o))))
              (3dc-from-list (car xyz-list) (cadr xyz-list) (caddr xyz-list) '3dc 5)))

(defmethod* transform-reflection ((bpcl bpc-lib) (n list) (o list))
            (make-instance 'bpc-lib :bpf-list 
                           (loop for bpc in (bpf-list bpcl)
                                 collect (transform-reflection bpc n o))))

(defmethod* transform-reflection ((3dcl 3dc-lib) (n list) (o list))
            (make-instance '3dc-lib :bpf-list 
                           (loop for 3dc in (bpf-list 3dcl)
                                 collect (transform-reflection 3dc n o))))


;--------


;==========Rotation


(defmethod* transform-rotation ((p list) (a list) (o list) (d number))
            :doc "the om equivalant of the modalisp 
(transform 'rotation sth-to-be-rotated axis-invariance origin point, angle of rotation in degree), 
the first argument could be:
It doesn't working properly with 2 dimensional points (x, y), but only with 3D points, if the element is 2D, it will add a third dimension automatically.
1. point of (list x y z)
2. list of points of (list x y z)
3. bpc (or in some case bpf)
4. bpc-lib (or in some case bpc-lib)
5. 3dc
6. 3dc-lib" 
            (if (atom (car p)) 
                (point-rotation p a o d)
              (mapcar #'(lambda (x) (point-rotation x a o d)) p)))
;(transform-rotation '(3 0 0) '(0 0 1) '(0 0 0) 90)
;(transform-rotation '((0 0 0) (5 0 0)) '(0 0 1) '(0 0 0) 90)

(defmethod* transform-rotation ((bpc bpc) (a list) (o list) (d number))
            (let* ((xy-list (mat-trans (transform-rotation (point-pairs bpc) a o d))))
              (simple-bpf-from-list (car xy-list) (cadr xy-list) 'bpc 5)))

(defmethod* transform-rotation ((3dc 3dc) (a list) (o list) (d number))
            (let* ((xyz-list (mat-trans (transform-rotation (point-pairs 3dc) a o d))))
              (3dc-from-list (car xyz-list) (cadr xyz-list) (caddr xyz-list) '3dc 5)))

(defmethod* transform-rotation ((bpcl bpc-lib) (a list) (o list) (d number))
            (make-instance 'bpc-lib :bpf-list 
                           (loop for bpc in (bpf-list bpcl)
                                 collect (transform-rotation bpc a o d))))

(defmethod* transform-rotation ((3dcl 3dc-lib) (a list) (o list) (d number))
            (make-instance '3dc-lib :bpf-list 
                           (loop for 3dc in (bpf-list 3dcl)
                                 collect (transform-rotation 3dc a o d))))


;-----------duplicate rotation

(defmethod* duplicate-rotation ((p list) (step number) (a list) (o list) (d number) (out-mode number))
            :menuins '((5 (("list" 0) ("3dc" 1) ("3dc-lib" 2))))
            :doc "the om equivalant of the modalisp 
(duplicate 'rotation sth-tobe-extruded repitition rotation-axis origin-of-rotation angle-of-rotation-in-degrees), 
the first argument could be:
1. point of (list x y z)
2. list of points of (list x y z)
3. list of list of points of (list x y z)
4. bpc (or in some case bpf)
5. bpf
6. 3dc
7. 3dc-lib"
            (graphic-out-format
             (cond 
              ((atom (car p)) (loop for i from 0 to step
                                    collect (point-rotation p a o (* d i))))
              ((atom (caar p)) (mat-trans (mapcar #'(lambda (x) (duplicate-rotation x step a o d 0)) p)))
              ((atom (caaar p)) (mat-trans (mapcar #'(lambda (x) (duplicate-rotation x step a o d 0)) (merge-graphics p *graphic-merge-method*))))
              )
             out-mode))

(defmethod* duplicate-rotation ((3dc 3dc) (step number) (a list) (o list) (d number) (out-mode number))
            (duplicate-rotation (point-pairs 3dc) step a o d out-mode))

(defmethod* duplicate-rotation ((3dcl 3dc-lib) (step number) (a list) (o list) (d number) (out-mode number))
            (duplicate-rotation 
             (merge-graphics (loop for 3dc in (bpf-list 3dcl)
                                   collect (point-pairs 3dc)) *graphic-merge-method*)
                   step a o d out-mode))

(defmethod* duplicate-rotation ((bpc bpc) (step number) (a list) (o list) (d number) (out-mode number))
            (duplicate-rotation (loop for p in (point-pairs bpc)
                                         collect (append p (list 0))) step a o d out-mode))

(defmethod* duplicate-rotation ((bpf bpf) (step number) (a list) (o list) (d number) (out-mode number))
            (duplicate-rotation (loop for p in (point-pairs bpf)
                                         collect (append p (list 0))) step a o d out-mode))


;===================================== Modalys Node Numerotation
(defmethod* graphic->point-map ((list list))
            :doc "convert all the possible format to point-pairs format (i.e. list of points) "
            (cond ((atom (car list)) (format nil "it is a single point, not graphic"))
                  ((atom (caar list)) list)
                  ((atom (caaar list)) (merge-graphics list *graphic-merge-method*))))

(defmethod* graphic->point-map ((3dc 3dc))
            (point-pairs 3dc))

(defmethod* graphic->point-map ((3dcl 3dc-lib))
            (graphic->point-map (mapcar #'point-pairs (bpf-list 3dcl))))


(defun node-numerotation (graphic)
  "numerote the node as index, by sort the point from every axis, output is in format of (point-map index-map)"            
  (loop for p in (sort-list (sort-list (sort-list (graphic->point-map graphic) :key #'car) :key #'cadr) :key #'caddr)
        for i from 0
        collect (list p i)))

(defmethod* node->coordinates (graphic (node number))
            "the first input could be graphic (list of points, list of list of points, 3dc, 3dc-lib) , or the result of node-numerotation, in order to reduce the calculation"
            (cond ((and (atom (cadar graphic)) (= 2 (length (car graphic)))) (car (nth (- node 1) graphic)))
                  (t (nth (- node 1) (node-numerotation graphic))))
                  )

(defmethod* node->coordinates (graphic (nodes list))
            (cond ((and (atom (caar graphic)) (= 2 (length (car graphic)))) (loop for node in nodes 
                                                                                  collect (car (nth (- node 1) graphic))))
                  (t (let ((map (node-numerotation graphic)))
                       (mapcar #'(lambda (x) (nth (- x 1) map)) nodes)))
                  ))

(defmethod* coordinates->node (graphic (coordinates list))
            (cond ((and (atom (caar graphic)) (= 2 (length (car graphic)))) 
                   (if (atom (car coordinates)) (cadr (assoc coordinates graphic :test #'equal)) 
                     (loop for coordinate in coordinates 
                           collect (cadr (assoc coordinates graphic :test #'equal)))))
                  (t 
                   (let ((map (node-numerotation graphic)))
                     (if (atom (car coordinates)) (cadr (assoc coordinates graphic :test #'equal)) 
                       (loop for coordinate in coordinates 
                             collect (cadr (assoc coordinates graphic :test #'equal))))))))



(defclass! mesh ()
           ((vertices :initform nil :initarg :vertices :accessor vertices :documentation "list of coordinates (list of list, depth = 2)"))
           (:icon 1998)
           (:documentation "the father class of all kind of mesh"))

(defclass! mesh-0d (mesh)
           ((single-points :initform nil :initarg :single-points :accessor single-points :documentation "the index of the nodes indicates the structure of the mesh" ))
           (:icon 1998)
           (:documentation "mesh of 0d, just a point"))

(defclass! mesh-1d (mesh)
           ((edges :initform nil :initarg :edges :accessor edges :documentation "the edges indicate the connection between each two nodes, it gives the structure of all the vertices"))
           (:icon 1998)
           (:documentation "mesh of 1d, constructed by edges or lines"))

(defclass! mesh-2d (mesh-1d)
           ((quadrilaterals :initform nil :initarg :quadrilaterals :accessor quadrilaterals :documentation "the quadrilaterals indicate the faces constructed by each four nodes, it gives the structure of all the vertices"))
           (:icon 1998)
           (:documentation "mesh of 2d, constructed by quadrilaterals"))

(defclass! mesh-3d (mesh-2d)
           ((hexahedra :initform nil :initarg :hexahedra :accessor hexahedra :documentation "the hexahedra indicate the 3d figure constructed by each eight nodes, it gives the structure of all the vertices")
            (surface-quadrilaterals :initform nil :initarg :surface-quadrilaterals :accessor surface-quadrilaterals :documentation "this is the quadrilaterals on the surface of the object"))
           (:icon 1998)
           (:documentation "mesh of 3d, constructed by hexahedra"))

(defmethod! make-mesh ((type string) (arg t))
            :menuins '((0 (("single-point" "single-point") ("add" "add") ("copy" "copy") ("read-from-file" "read-from-file") ("restrict-point" "restrict-point") ("restrict-edge" "restrict-edge") ("restrict-plane" "restrict-plane") ("restrict-quadrilateral" "restrict-quadrilateral"))))
            :doc "equivalant of the modalys function make-mesh"
            ;:numouts 2 ;also one for generating text automatically
            (cond ((equal type "single-point") (cond ((atom (car arg)) (make-instance 'mesh-0d :vertices (list arg) :single-points (list 1)))
                                                     ((atom (caar arg)) (make-instance 'mesh-0d :vertices arg :single-points (loop for i from 1 to (length arg) collect i)))
                                                     (t (error "make-mesh 'single-point: 2. input have to be eight a point of xyz, or list of points of xyz"))
                                                     ))
                  ((equal type "add") t)
                  ((equal type "copy") t)
                  ((equal type "read-from-file") t)
                  ((equal type "restrict-point") t)
                  ((equal type "restrict-edge") t)
                  ((equal type "restrict-plane") t)
                  ((equal type "restrict-quadrilateral") t)
                  ))


(defmethod! mesh-viewer ((mesh mesh-0d))
            (make-instance '3dc-lib 
                           :bpf-list (loop for p in (vertices mesh)
                                           collect (3dc-from-list (list (car p)) (list (cadr p)) (list (caddr p)) '3dc 5))))

(defmethod! m_dup-translation ((mesh mesh-0d) (step number) (m list))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh.
for example, if the input is a mesh-0d, the output will be a mesh-1d"
            (let* ((o-vertices (vertices mesh))
                   (o-single-points (single-points mesh))
                   (point-num (length o-single-points))
                   (r-vertices (reverse o-vertices))
                   (r-edges nil)
                   )
              (loop for point in o-vertices
                    for index in o-single-points
                    do 
                    (loop for i from 1 to step
                          do 
                          (if (= i 1) 
                              (progn 
                                (push (point-translation point m) r-vertices)
                                (push (list index (incf point-num)) r-edges))
                            (progn 
                              (push (point-translation (car r-vertices) m) r-vertices)
                              (push (list point-num (incf point-num)) r-edges))
                            )))
              (make-instance 'mesh-1d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             )))

(defmethod! mesh-viewer ((mesh mesh-1d))
            (make-instance '3dc-lib 
                           :bpf-list (let* ((points (vertices mesh))) 
                                       (loop for edge in (edges mesh)
                                             for xyz = (mat-trans (mapcar #'(lambda (x) (nth (- x 1) points)) edge))
                                             collect (3dc-from-list (car xyz) (cadr xyz) (caddr xyz) '3dc 5)))))

(defmethod! m_dup-translation ((mesh mesh-1d) (step number) (m list))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh.
for example, if the input is a mesh-1d, the output will be a mesh-2d"
            (let* ((o-vertices (vertices mesh))
                   (o-edges (edges mesh))
                   (edge-num (length o-edges))
                   (point-num (length o-vertices))
                   (used-start-point nil)
                   (r-vertices (reverse o-vertices))
                   (r-edges (reverse o-edges))
                   (r-quadrilaterals nil)
                   )
              (loop for i from 1 to edge-num
                    for edge = (nth (- i 1) o-edges)
                    for edge-points = (mapcar #'(lambda (x) (nth (- x 1) o-vertices)) edge)
                    do
                    (progn 
                      (if (not (find (car edge) used-start-point))
                          (loop for j from 1 to step
                                if (= j 1) 
                                do
                                (progn 
                                  (push (point-translation (car edge-points) m) r-vertices)
                                  (push (list (car edge) (incf point-num)) r-edges)
                                  (setf used-start-point (append used-start-point edge)))
                                else
                                do
                                (progn 
                                  (push (point-translation (car r-vertices) m) r-vertices)
                                  (push (list point-num (incf point-num)) r-edges))
                                ))
                      (loop for j from 1 to step
                            if (= j 1)
                            do
                            (progn
                              (push (point-translation (cadr edge-points) m) r-vertices)
                              (push (list (cadr edge) (incf point-num)) r-edges)
                              (push (list (car edge) (cadr edge) point-num (- point-num step)) r-quadrilaterals)
                              (push (list (- point-num step) point-num) r-edges)
                              (setf used-start-point (append used-start-point edge))
                              )
                            else
                            do
                            (progn
                              (push (point-translation (car r-vertices) m) r-vertices)
                              (push (list (- point-num step) point-num (+ point-num 1) (- point-num step -1)) r-quadrilaterals)
                              (push (list point-num (incf point-num)) r-edges)
                              (push (list (- point-num step) point-num) r-edges)
                              )
                            )))
              (make-instance 'mesh-2d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             :quadrilaterals (reverse r-quadrilaterals)
                             )))

(defmethod! mesh-viewer ((mesh mesh-2d))
            (make-instance '3dc-lib 
                           :bpf-list (let* ((points (vertices mesh))) 
                                       (loop for quadrilateral in (quadrilaterals mesh)
                                             for xyz = (mat-trans (mapcar #'(lambda (x) (nth (- x 1) points)) (append quadrilateral (list (car quadrilateral)))))
                                             collect (3dc-from-list (car xyz) (cadr xyz) (caddr xyz) '3dc 5)))))

(defun node-connected (n edge-list)
  (let ((r nil))
    (loop for edge in edge-list
          if (find n edge)
          do
          (push edge r))
    (reverse r)))

(defun num-node-connect (n edge-list)
  (let ((i 0))
    (loop for edge in edge-list
          if (find n edge)
          do
          (incf i))
    i))

#|
;this is sth very cpu-expensive, run time = 4000ms
(defun surface-quad-filter (quad-list edge-list)
  "more efficient that num-node-connect"
  (remove nil (loop for quad in quad-list
                    collect
                    (do* ((f (flat edge-list))
                          (v (vector 0 0 0 0))  ;vector
                          (rest f (cdr rest))    ;cdr-loop
                          (i (car rest) (car rest))   ;car 
                          (pos (position i quad) (position i quad))  ;position
                          (n-c (if pos (incf (aref v pos)) 0) (if pos (incf (aref v pos)) 0)) ;new-counter-value
                          (s (if (> n-c 5) t) (if (> n-c 5) t)))
                         ((or s (null i)) (if s nil quad))
                       ))))
;(surface-quad-filter '((1 2 3 4) (2 3 4 6) (4 6 4 3)) '((1 2) (2 4) (4 3) (3 2) (2 5) (2 5) (2 5) (2 5) (2 5) (2 5) (2 5)))


|#

;this version is optimized, written particularly for m-dup-translation, 2d->3d, about 160 times more quicker... 
(defun surface-quad-filter (quad-list edge-list point-long)
  "more efficient that num-node-connect"
  (let* ((v-h (make-array (+ point-long 1) :initial-element 0))
         (r-quad))
      (loop for edge in edge-list
            do 
            (loop for pnt in edge
                  do 
                  (incf (aref v-h pnt))))
      (loop for quad in quad-list
            do
            (if (loop for tpnt in quad
                      if (> (aref v-h tpnt) 5)
                      return t)
                nil
              (push quad r-quad)))
      (reverse r-quad)))


(defun node-index-from-base (o-point-num base step-i step-num)
  "support function for 2d->3d extrusion"
  (+ o-point-num step-i (* (- base 1) step-num)))

(defmethod nth-rec ((i number) (el list))
  (nth i el))
(defmethod nth-rec ((l list) (el list))
  (mapcar #'(lambda (x) (nth-rec x el)) l))

(defun hex->quadrilaterals (hex-index)
  (nth-rec '((0 1 2 3)
             (4 5 6 7)
             (0 1 5 4)
             (3 2 6 7)
             (0 3 7 4)
             (1 2 6 5)) hex-index))
;(hex->quadrilaterals '("1" "2" "3" "4" "5" "6" "7" "8"))

(defmethod! m_dup-translation ((mesh mesh-2d) (step number) (m list))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh. for example, if the input is a mesh-2d, the output will be a mesh-3d"
            (let* ((o-vertices (vertices mesh))
                   (o-edges (edges mesh))
                   (o-quadrilaterals (quadrilaterals mesh))
                   (o-point-num (length o-vertices))
                   (point-num (length o-vertices))
                   (edge-num (length o-edges))
                   (r-vertices (reverse o-vertices))
                   (r-edges (reverse o-edges))
                   (r-quadrilaterals nil)
                   (r-hexahedra nil)
                   )
              (loop for i from 1 to (length o-vertices)
                    for point = (nth (- i 1) o-vertices)
                    do
                    (loop for j from 1 to step
                          do
                          (push (point-translation point (om* m j)) r-vertices)
                          (push (list (if (= j 1) i point-num) (incf point-num)) r-edges)
                          ))
              (loop for i from 1 to (length o-edges) 
                    for edge = (nth (- i 1) o-edges)
                    for edge1 = (car edge)
                    for edge2 = (cadr edge)
                    do
                    (loop for j from 1 to step
                          do
                          (push (list (node-index-from-base o-point-num edge1 j step) (node-index-from-base o-point-num edge2 j step)) r-edges)))
              (loop for i from 1 to (length o-quadrilaterals)
                    for quad = (nth (- i 1) o-quadrilaterals)
                    do
                    (loop for j from 1 to step
                          do
                          (if (= j 1) 
                              (push (append quad (mapcar #'(lambda (x) (node-index-from-base o-point-num x j step)) quad)) r-hexahedra)
                            (let ((depart (last-n (car r-hexahedra) 4)))
                              (push (append depart (mapcar #'(lambda (x) (node-index-from-base o-point-num x j step)) quad)) r-hexahedra)))))

              (setf r-quadrilaterals (remove-duplicates (loop for hex in r-hexahedra
                                                              append
                                                              (hex->quadrilaterals hex)) :test #'equal))

#| ==== this block is even slower than before..  53 ms vs 68 ms
              (loop for hex in r-hexahedra
                    do
                    (loop for quad in (hex->quadrilaterals hex)
                          do 
                          (if (find quad r-quadrilaterals :test #'equal) 
                              nil 
                            (push quad r-quadrilaterals))))
|#

              (make-instance 'mesh-3d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             :quadrilaterals (reverse r-quadrilaterals)
                             :surface-quadrilaterals (surface-quad-filter r-quadrilaterals r-edges (length r-vertices))
                             :hexahedra (reverse r-hexahedra)
                             )))

(defun insert-after (lst index newelt)
  (push newelt (cdr (nthcdr index lst))) 
  lst)

(defmethod! mesh-viewer-3d ((mesh mesh-3d) (mode string))
            :menuins '((1 (("unit:hex" "unit:hex") ("unit:quad" "unit:quad") ("unit:surf" "unit:surf") ("unit:edge" "unit:edge") ("unit:point" "unit:point"))))
            (make-instance '3dc-lib
                           :bpf-list 
                           (let* ((points (vertices mesh)))
                             (if (equal mode "unit:point") 
                                 (loop for xyz in points
                                       collect (3dc-from-list (list (car xyz)) (list (cadr xyz)) (last xyz) '3dc 5))
                               (loop for hex in (cond ((equal mode "unit:hex") (hexahedra mesh))
                                                             ((equal mode "unit:surf") (surface-quadrilaterals mesh))
                                                             ((equal mode "unit:quad") (quadrilaterals mesh))
                                                             (t (edges mesh))
                                                             )
                                     for xyz = (mat-trans (mapcar #'(lambda (x) (nth (- x 1) points)) 
                                                                  (cond ((equal mode "unit:hex") (append (insert-after hex 3 (car hex)) (list (nth 5 hex))))
                                                                        ((equal mode "unit:surf") (append hex (list (car hex))))
                                                                        ((equal mode "unit:quad") (append hex (list (car hex))))
                                                                        (t hex)
                                                                        )))
                                     collect (3dc-from-list (car xyz) (cadr xyz) (caddr xyz) '3dc 5))))
                           ))



;============== mesh homothety
;"p=input point, c=center point, r=homothety rate"

(defmethod! m_dup-homothety ((mesh mesh-0d) (step number) (c list) (r number))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh.
for example, if the input is a mesh-0d, the output will be a mesh-1d"
            (let* ((o-vertices (vertices mesh))
                   (o-single-points (single-points mesh))
                   (point-num (length o-single-points))
                   (r-vertices (reverse o-vertices))
                   (r-edges nil)
                   )
              (loop for point in o-vertices
                    for index in o-single-points
                    do 
                    (loop for i from 1 to step
                          do 
                          (if (= i 1) 
                              (progn 
                                (push (point-homothety point c r) r-vertices)
                                (push (list index (incf point-num)) r-edges))
                            (progn 
                              (push (point-homothety (car r-vertices) c r) r-vertices)
                              (push (list point-num (incf point-num)) r-edges))
                            )))
              (make-instance 'mesh-1d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             )))

(defmethod! m_dup-homothety ((mesh mesh-1d) (step number) (c list) (r number))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh.
for example, if the input is a mesh-1d, the output will be a mesh-2d"
            (let* ((o-vertices (vertices mesh))
                   (o-edges (edges mesh))
                   (edge-num (length o-edges))
                   (point-num (length o-vertices))
                   (used-start-point nil)
                   (r-vertices (reverse o-vertices))
                   (r-edges (reverse o-edges))
                   (r-quadrilaterals nil)
                   )
              (loop for i from 1 to edge-num
                    for edge = (nth (- i 1) o-edges)
                    for edge-points = (mapcar #'(lambda (x) (nth (- x 1) o-vertices)) edge)
                    do
                    (progn 
                      (if (not (find (car edge) used-start-point))
                          (loop for j from 1 to step
                                if (= j 1) 
                                do
                                (progn 
                                  (push (point-homothety (car edge-points) c r) r-vertices)
                                  (push (list (car edge) (incf point-num)) r-edges)
                                  (setf used-start-point (append used-start-point edge)))
                                else
                                do
                                (progn 
                                  (push (point-homothety (car r-vertices) c r) r-vertices)
                                  (push (list point-num (incf point-num)) r-edges))
                                ))
                      (loop for j from 1 to step
                            if (= j 1)
                            do
                            (progn
                              (push (point-homothety (cadr edge-points) c r) r-vertices)
                              (push (list (cadr edge) (incf point-num)) r-edges)
                              (push (list (car edge) (cadr edge) point-num (- point-num step)) r-quadrilaterals)
                              (push (list (- point-num step) point-num) r-edges)
                              (setf used-start-point (append used-start-point edge))
                              )
                            else
                            do
                            (progn
                              (push (point-homothety (car r-vertices) c r) r-vertices)
                              (push (list (- point-num step) point-num (+ point-num 1) (- point-num step -1)) r-quadrilaterals)
                              (push (list point-num (incf point-num)) r-edges)
                              (push (list (- point-num step) point-num) r-edges)
                              )
                            )))
              (make-instance 'mesh-2d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             :quadrilaterals (reverse r-quadrilaterals)
                             )))

(defmethod! m_dup-homothety ((mesh mesh-2d) (step number) (c list) (r number))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh. for example, if the input is a mesh-2d, the output will be a mesh-3d"
            (let* ((o-vertices (vertices mesh))
                   (o-edges (edges mesh))
                   (o-quadrilaterals (quadrilaterals mesh))
                   (o-point-num (length o-vertices))
                   (point-num (length o-vertices))
                   (edge-num (length o-edges))
                   (r-vertices (reverse o-vertices))
                   (r-edges (reverse o-edges))
                   (r-quadrilaterals nil)
                   (r-hexahedra nil)
                   )
              (loop for i from 1 to (length o-vertices)
                    for point = (nth (- i 1) o-vertices)
                    do
                    (loop for j from 1 to step
                          do
                          (push (point-homothety point c (om^ r j)) r-vertices)
                          (push (list (if (= j 1) i point-num) (incf point-num)) r-edges)
                          ))
              (loop for i from 1 to (length o-edges) 
                    for edge = (nth (- i 1) o-edges)
                    for edge1 = (car edge)
                    for edge2 = (cadr edge)
                    do
                    (loop for j from 1 to step
                          do
                          (push (list (node-index-from-base o-point-num edge1 j step) (node-index-from-base o-point-num edge2 j step)) r-edges)))
              (loop for i from 1 to (length o-quadrilaterals)
                    for quad = (nth (- i 1) o-quadrilaterals)
                    do
                    (loop for j from 1 to step
                          do
                          (if (= j 1) 
                              (push (append quad (mapcar #'(lambda (x) (node-index-from-base o-point-num x j step)) quad)) r-hexahedra)
                            (let ((depart (last-n (car r-hexahedra) 4)))
                              (push (append depart (mapcar #'(lambda (x) (node-index-from-base o-point-num x j step)) quad)) r-hexahedra)))))

              (setf r-quadrilaterals (remove-duplicates (loop for hex in r-hexahedra
                                                              append
                                                              (hex->quadrilaterals hex)) :test #'equal))
              (make-instance 'mesh-3d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             :quadrilaterals (reverse r-quadrilaterals)
                             :surface-quadrilaterals (surface-quad-filter r-quadrilaterals r-edges (length r-vertices))
                             :hexahedra (reverse r-hexahedra)
                             )))



;============== mesh rotation
;"p=input point, a=axis (preferable just use 1 and 0), o=origin point, d=angle of rotation in degrees"

(defmethod! m_dup-rotation ((mesh mesh-0d) (step number) (a list) (o list) (d number))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh.
for example, if the input is a mesh-0d, the output will be a mesh-1d"
            (let* ((o-vertices (vertices mesh))
                   (o-single-points (single-points mesh))
                   (point-num (length o-single-points))
                   (r-vertices (reverse o-vertices))
                   (r-edges nil)
                   )
              (loop for point in o-vertices
                    for index in o-single-points
                    do 
                    (loop for i from 1 to step
                          do 
                          (if (= i 1) 
                              (progn 
                                (push (point-rotation point a o d) r-vertices)
                                (push (list index (incf point-num)) r-edges))
                            (progn 
                              (push (point-rotation (car r-vertices) a o d) r-vertices)
                              (push (list point-num (incf point-num)) r-edges))
                            )))
              (make-instance 'mesh-1d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             )))

(defmethod! m_dup-rotation ((mesh mesh-1d) (step number) (a list) (o list) (d number))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh.
for example, if the input is a mesh-1d, the output will be a mesh-2d"
            (let* ((o-vertices (vertices mesh))
                   (o-edges (edges mesh))
                   (edge-num (length o-edges))
                   (point-num (length o-vertices))
                   (used-start-point nil)
                   (r-vertices (reverse o-vertices))
                   (r-edges (reverse o-edges))
                   (r-quadrilaterals nil)
                   )
              (loop for i from 1 to edge-num
                    for edge = (nth (- i 1) o-edges)
                    for edge-points = (mapcar #'(lambda (x) (nth (- x 1) o-vertices)) edge)
                    do
                    (progn 
                      (if (not (find (car edge) used-start-point))
                          (loop for j from 1 to step
                                if (= j 1) 
                                do
                                (progn 
                                  (push (point-rotation (car edge-points) a o d) r-vertices)
                                  (push (list (car edge) (incf point-num)) r-edges)
                                  (setf used-start-point (append used-start-point edge)))
                                else
                                do
                                (progn 
                                  (push (point-rotation (car r-vertices) a o d) r-vertices)
                                  (push (list point-num (incf point-num)) r-edges))
                                ))
                      (loop for j from 1 to step
                            if (= j 1)
                            do
                            (progn
                              (push (point-rotation (cadr edge-points) a o d) r-vertices)
                              (push (list (cadr edge) (incf point-num)) r-edges)
                              (push (list (car edge) (cadr edge) point-num (- point-num step)) r-quadrilaterals)
                              (push (list (- point-num step) point-num) r-edges)
                              (setf used-start-point (append used-start-point edge))
                              )
                            else
                            do
                            (progn
                              (push (point-rotation (car r-vertices) a o d) r-vertices)
                              (push (list (- point-num step) point-num (+ point-num 1) (- point-num step -1)) r-quadrilaterals)
                              (push (list point-num (incf point-num)) r-edges)
                              (push (list (- point-num step) point-num) r-edges)
                              )
                            )))
              (make-instance 'mesh-2d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             :quadrilaterals (reverse r-quadrilaterals)
                             )))

(defmethod! m_dup-rotation ((mesh mesh-2d) (step number) (a list) (o list) (d number))
            :doc "this is a duplicate-translation for particularly for mesh, input and output are all mesh objects. The duplicate will add a new dimension to the original mesh. for example, if the input is a mesh-2d, the output will be a mesh-3d"
            (let* ((o-vertices (vertices mesh))
                   (o-edges (edges mesh))
                   (o-quadrilaterals (quadrilaterals mesh))
                   (o-point-num (length o-vertices))
                   (point-num (length o-vertices))
                   (edge-num (length o-edges))
                   (r-vertices (reverse o-vertices))
                   (r-edges (reverse o-edges))
                   (r-quadrilaterals nil)
                   (r-hexahedra nil)
                   )
              (loop for i from 1 to (length o-vertices)
                    for point = (nth (- i 1) o-vertices)
                    do
                    (loop for j from 1 to step
                          do
                          (push (point-rotation point a o (* d j)) r-vertices)
                          (push (list (if (= j 1) i point-num) (incf point-num)) r-edges)
                          ))
              (loop for i from 1 to (length o-edges) 
                    for edge = (nth (- i 1) o-edges)
                    for edge1 = (car edge)
                    for edge2 = (cadr edge)
                    do
                    (loop for j from 1 to step
                          do
                          (push (list (node-index-from-base o-point-num edge1 j step) (node-index-from-base o-point-num edge2 j step)) r-edges)))
              (loop for i from 1 to (length o-quadrilaterals)
                    for quad = (nth (- i 1) o-quadrilaterals)
                    do
                    (loop for j from 1 to step
                          do
                          (if (= j 1) 
                              (push (append quad (mapcar #'(lambda (x) (node-index-from-base o-point-num x j step)) quad)) r-hexahedra)
                            (let ((depart (last-n (car r-hexahedra) 4)))
                              (push (append depart (mapcar #'(lambda (x) (node-index-from-base o-point-num x j step)) quad)) r-hexahedra)))))

              (setf r-quadrilaterals (remove-duplicates (loop for hex in r-hexahedra
                                                              append
                                                              (hex->quadrilaterals hex)) :test #'equal))
              (make-instance 'mesh-3d 
                             :vertices (reverse r-vertices)
                             :edges (reverse r-edges)
                             :quadrilaterals (reverse r-quadrilaterals)
                             :surface-quadrilaterals (surface-quad-filter r-quadrilaterals r-edges (length r-vertices))
                             :hexahedra (reverse r-hexahedra)
                             )))


#|
todo:

1. make-mesh forge: remove the repeated vertices, give a maximum difference (tolerence) of the distance between the repeated point. after sort the vertices by xyz, substitute the original vertice index in the other slots, recalculate the surface quad, 
2. make-mesh add: combine two mesh, and forge them together
(or should they all written under one method? like the make-mesh add in modalys? )


3. save-mesh: write the mesh into a .mesh file, which could be opened and viewed by Modalys.
(optional) 4. convert the patch into modalys file and save it into a lisp file... (kind of translator, actually not interesting..) ;better to do it in om# !

5. mesh-filter: subtractive processing of a mesh:
6. transform mesh .. 
7. preview the 3dc-lib in 3dc in order to avoid the too-many-argument error.
8. scale-mesh 
9. resample-mesh: the reduce the number of hex, but keep the shape almost invariance, by combine 2 or 4 or 8 mesh together.. (or make use sample)
10. mesh*
11. mesh+
12. mesh-cut (maybe too difficult for hex.. hmm)

|#

;================
;make-mesh 'forge
;================



